var wsctRunner = {
  onLoad: function() {
  },

// wsctSecurityInformation: This function is based on information available
//   on the Mozilla Developer Network page entitled: How to check the
//   security state of an XMLHTTPRequest over SSL
  wsctSecurityInformation: function(requestChannel) {
    const localNSSErrorsService = Components.interfaces.nsINSSErrorsService;
    var localErrorStatus = requestChannel.channel.QueryInterface(Components.interfaces.nsIRequest).status;
    var localErrorClass = null;
    var localErrorType = "";
    var localErrorName = "";
    var localSecInfoText = "";
    var localSSLInfoText = "";
    var localNSSerror = null;
    if ((localErrorStatus& 0xff0000) === 0x5a0000) {
      try {
        localErrorClass = Components.classes["@mozilla.org/nss_errors_service;1"]
                                    .getService(localNSSErrorsService).getErrorClass(localErrorStatus);
      } catch(ex) {
        localErrorClass = document.getElementById("wsctStrings").getString("wsctErrorType1");
      }
      if (localErrorClass == localNSSErrorsService.ERROR_CLASS_BAD_CERT) {
        localErrorType = document.getElementById("wsctStrings").getString("wsctErrorType2");
      } else {
        localErrorType = document.getElementById("wsctStrings").getString("wsctErrorType1");
      }
      if ((localErrorStatus& 0xffff) < Math.abs(localNSSErrorsService.NSS_SEC_ERROR_BASE)) {
        localNSSerror = Math.abs(localNSSErrorsService.NSS_SEC_ERROR_BASE) - (localErrorStatus& 0xffff);
        switch (localNSSerror) {
          case 11: localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName1");
          break;
          case 12: localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName2");
          break;
          case 13:
          case 20:
          case 21:
          case 36:
            localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName3");
          break;
          case 90: localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName4");
          break;
          case 176: localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName5");
          break;
          default: localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName6");
          break;
        }
      } else {
        localNSSerror = Math.abs(localNSSErrorsService.NSS_SSL_ERROR_BASE) - (localErrorStatus& 0xffff);
        switch (localNSSerror) {
          case 3: localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName7");
          break;
          case 4: localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName8");
          break;
          case 8: localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName9");
          break;
          case 9: localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName10");
          break;
          case 12: localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName11");
          break;
          default: localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName6");
          break;
        }
      }
    } else {
      localErrorType = document.getElementById("wsctStrings").getString("wsctErrorType3");
      switch (localErrorStatus) {
        case 0x804B000C: localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName12");
        break;
        case 0x804B000E: localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName13");
        break;
        case 0x804B001E: localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName14");
        break;
        case 0x804B0047: localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName15");
        break;
        default: localErrorName = document.getElementById("wsctStrings").getString("wsctErrorName6");
        break;
      }
    }

    try {
      var localSecInfo = requestChannel.channel.securityInfo;
      if (localSecInfo instanceof Components.interfaces.nsITransportSecurityInfo) {
        localSecInfo.QueryInterface(Components.interfaces.nsITransportSecurityInfo);
        if ((localSecInfo.securityState & Components.interfaces.nsIWebProgressListener.STATE_IS_INSECURE) == Components.interfaces.nsIWebProgressListener.STATE_IS_INSECURE) {
          localSecInfoText = document.getElementById("wsctStrings").getString("wsctSecurityState1");
        } else if ((localSecInfo.securityState & Components.interfaces.nsIWebProgressListener.STATE_IS_BROKEN) == Components.interfaces.nsIWebProgressListener.STATE_IS_BROKEN) {
          localSecInfoText = document.getElementById("wsctStrings").getString("wsctSecurityState2");
        } else {
          localSecInfoText = document.getElementById("wsctStrings").getString("wsctSecurityState3");
        }
      } else {
        localSecInfoText = document.getElementById("wsctStrings").getString("wsctSecurityState4");
      }
      if (localSecInfo instanceof Components.interfaces.nsISSLStatusProvider) {
        var localSSLcertInfo = localSecInfo.QueryInterface(Components.interfaces.nsISSLStatusProvider).SSLStatus.QueryInterface(Components.interfaces.nsISSLStatus).serverCert;
        localSSLInfoText = document.getElementById("wsctStrings").getString("wsctSSLinfoLine1") + "\n\n";
        localSSLInfoText = localSSLInfoText+document.getElementById("wsctStrings").getString("wsctSSLinfoLine2") + "\n\t";
        localSSLInfoText = localSSLInfoText+document.getElementById("wsctStrings").getString("wsctSSLinfoLine4")+" "+localSSLcertInfo.commonName+"\n\t";
        localSSLInfoText = localSSLInfoText+document.getElementById("wsctStrings").getString("wsctSSLinfoLine5")+" "+localSSLcertInfo.organization+"\n\t";
        localSSLInfoText = localSSLInfoText+document.getElementById("wsctStrings").getString("wsctSSLinfoLine6")+" "+localSSLcertInfo.organizationalUnit+"\n\n";
        localSSLInfoText = localSSLInfoText+document.getElementById("wsctStrings").getString("wsctSSLinfoLine3") + "\n\t";
        localSSLInfoText = localSSLInfoText+document.getElementById("wsctStrings").getString("wsctSSLinfoLine4")+" "+localSSLcertInfo.issuerCommonName+"\n\t";
        localSSLInfoText = localSSLInfoText+document.getElementById("wsctStrings").getString("wsctSSLinfoLine5")+" "+localSSLcertInfo.issuerOrgnaization+"\n\t";
        localSSLInfoText = localSSLInfoText+document.getElementById("wsctStrings").getString("wsctSSLinfoLine6")+" "+localSSLcertInfo.issuerOrganizationalUnit+"\n\n";
        localSSLInfoText = localSSLInfoText+document.getElementById("wsctStrings").getString("wsctSSLinfoLine7") + "\n\t";
        localSSLInfoText = localSSLInfoText+document.getElementById("wsctStrings").getString("wsctSSLinfoLine8")+" "+localSSLcertInfo.sha1Fingerprint+"\n\t";
        var localSSLvalidity = localSSLcertInfo.validity.QueryInterface(Components.interfaces.nsIX509CertValidity);
        localSSLInfoText = localSSLInfoText+document.getElementById("wsctStrings").getString("wsctSSLinfoLine9")+" "+localSSLvalidity.notBeforeGMT+"\n\t";
        localSSLInfoText = localSSLInfoText+document.getElementById("wsctStrings").getString("wsctSSLinfoLine10")+" "+localSSLvalidity.notAfterGMT+"\n";
      }
    } catch(ex) {
      localSecInfoText = document.getElementById("wsctStrings").getString("wsctSecurityState3");
    }
    var localErrorTitle = "";
    var localErrorMessage = "";
    if (localErrorName.length > 0) { localErrorTitle = localErrorName; }
    if (localErrorType.length > 0) {
      if (localErrorTitle.length > 0) { localErrorTitle = localErrorType + ": " + localErrorTitle;
      } else { localErrorTitle = localErrorType; }
    }
    if (localSSLInfoText.length > 0) { localErrorMessage = localSSLInfoText; }
    if (localSecInfoText.length > 0) {
      if (localErrorMessage.length > 0) { localErrorMessage = localSecInfoText + "\n\n" + localErrorMessage;
      } else { localErrorMessage = localSecInfoText; }
    }
    if (localErrorTitle.length <= 0) { localErrorTitle = document.getElementById("wsctStrings").getString("wsctGenericErrorTitle"); }
    if (localErrorMessage.length <= 0) { localErrorMessage = document.getElementById("wsctStrings").getString("wsctGenericErrorMessage"); }
    var localErrorPrompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                             .getService(Components.interfaces.nsIPromptService);
    localErrorPrompt.alert(null,localErrorTitle,localErrorMessage);
  },

  wsctSendToClipboard: function(localClipboardToken) {
    var localToken = parseInt(localClipboardToken);
    const gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
                                    .getService(Components.interfaces.nsIClipboardHelper);
    if (localToken == 1) {
      gClipboardHelper.copyString(String(document.getElementById("wsctResponseBodyText").textContent));
    } else {
      gClipboardHelper.copyString(String(document.getElementById("wsctResponseHeadersText").textContent));
    }
  },

  wsctProcessQuery: function(localURL, localQueryToken) {
    document.getElementById("wsctRunnerStatusLabel").setAttribute("value",
                  document.getElementById("wsctStrings").getString("wsctStatusLabel1"));
    var localURLrequestBody = "";
    document.getElementById("wsctResponseHeadersText").textContent = "";
    document.getElementById("wsctResponseBodyText").textContent = "";
    var LocalChannel = new XMLHttpRequest;
    try {
      LocalChannel.onreadystatechange = function() {
        if (LocalChannel.readyState == 4) {
          document.getElementById("wsctRunnerStatusLabel").setAttribute("value",
                    document.getElementById("wsctStrings").getString("wsctStatusLabel2"));
          document.getElementById("wsctResponseCodesCol2Value").value = String(LocalChannel.status);
          document.getElementById("wsctResponseCodesCol4Value").value = String(LocalChannel.statusText);
          document.getElementById("wsctResponseHeadersText").textContent = String(LocalChannel.getAllResponseHeaders());
          document.getElementById("wsctResponseBodyText").textContent = String(LocalChannel.responseText);
        }
      };
      LocalChannel.addEventListener("error",
        function(e) { wsctRunner.wsctSecurityInformation(LocalChannel); },
        false);
      switch (localQueryToken) {
        case 1: LocalChannel.open("HEAD",localURL,true);
          localURLrequestBody = null;
          break;
        case 2: LocalChannel.open("OPTIONS",localURL,true);
          localURLrequestBody = null;
          break;
        case 3: LocalChannel.open("PROPFIND",localURL,true);
          LocalChannel.setRequestHeader("Depth","0");
          localURLrequestBody = "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n" +
                               "<D:propfind xmlns:D=\"DAV:\">\n  <D:allprop />\n</D:propfind>\n";
          break;
        case 4: LocalChannel.open("PROPFIND",localURL,true);
          LocalChannel.setRequestHeader("Depth","1");
          localURLrequestBody = "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n" +
                               "<D:propfind xmlns:D=\"DAV:\">\n  <D:allprop />\n</D:propfind>\n";
          break;
        case 5: LocalChannel.open("PROPFIND",localURL,true);
          LocalChannel.setRequestHeader("Depth","Infinity");
          localURLrequestBody = "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n" +
                               "<D:propfind xmlns:D=\"DAV:\">\n  <D:allprop />\n</D:propfind>\n";
          break;
        case 6: LocalChannel.open("PROPFIND",localURL,true);
          LocalChannel.setRequestHeader("Depth","0");
          localURLrequestBody = "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n" +
                               "<D:propfind xmlns:D=\"DAV:\">\n  <D:propname />\n</D:propfind>\n";
          break;
        case 7: LocalChannel.open("PROPFIND",localURL,true);
          LocalChannel.setRequestHeader("Depth","1");
          localURLrequestBody = "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n" +
                               "<D:propfind xmlns:D=\"DAV:\">\n  <D:propname />\n</D:propfind>\n";
          break;
        case 8: LocalChannel.open("PROPFIND",localURL,true);
          LocalChannel.setRequestHeader("Depth","Infinity");
          localURLrequestBody = "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n" +
                               "<D:propfind xmlns:D=\"DAV:\">\n  <D:propname />\n</D:propfind>\n";
          break;
        case 9: LocalChannel.open("PROPFIND",localURL,true);
          LocalChannel.setRequestHeader("Depth","0");
          localURLrequestBody = "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n" +
                               "<D:propfind xmlns:D=\"DAV:\" xmlns:C=\"urn:ietf:params:xml:ns:carddav\">\n" +
                               "  <D:prop>\n    <C:addressbook-description />\n    <C:supported-address-data />\n" +
                               "    <C:addressbook-home-set />\n    <C:principal-address />\n" +
                               "    <C:max-resource-size />\n    <D:principal-URL />\n  </D:prop>\n</D:propfind>\n";
          break;
        case 10: LocalChannel.open("REPORT",localURL,true);
          LocalChannel.setRequestHeader("Depth","1");
          localURLrequestBody = "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n" +
                               "<C:addressbook-query xmlns:D=\"DAV:\" xmlns:C=\"urn:ietf:params:xml:ns:carddav\">\n" +
                               "  <D:prop>\n    <C:address-data content-type=\"text/vcard\" version=\"3.0\" />\n  </D:prop>\n</C:addressbook-query>\n";
          break;
        case 11: // Custom query
          var localDialogParams = {out:null};
          var localRetVal = window.openDialog("chrome://wsvrchecktool/content/wsctcustom.xul", "",
                            "chrome, dialog, modal, resizable=yes", localDialogParams).focus();
          var localReturnArray = localDialogParams.out;
          if (Array.isArray(localReturnArray)) {
            LocalChannel.open(String(localReturnArray[0]),localURL,true);
            if (String(localReturnArray[0]) != "SEARCH") {
              LocalChannel.setRequestHeader("Depth",String(localReturnArray[1]));
            }
            localURLrequestBody = String(localReturnArray[2]);
          } else {
            LocalChannel.open("OPTIONS",localURL,true);
            localURLrequestBody = null;
          }
          break;
        default: LocalChannel.open("HEAD",localURL,true);
          localURLrequestBody = null;
      }
      LocalChannel.send(localURLrequestBody);
    } catch(e) {
      document.getElementById("wsctRunnerStatusLabel").setAttribute("value",
                  document.getElementById("wsctStrings").getString("wsctStatusLabel3"));
      var localPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                             .getService(Components.interfaces.nsIPromptService);
      var localPromptTitle = document.getElementById("wsctStrings").getString("wsctQueryTitle");
      var localPromptMessage = document.getElementById("wsctStrings").getString("wsctQueryText");
      localPrompts.alert(null,localPromptTitle,localPromptMessage);
    }
  },

  wsctSendQuery: function() {
    var localPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                           .getService(Components.interfaces.nsIPromptService);
    var localPromptTitle = document.getElementById("wsctStrings").getString("wsctPromptTitle");
    var localPromptMessage = "";
    var localToken = parseInt(document.getElementById("wsctRunnerQueryBoxMenulist").selectedItem.value);
    if (isFinite(localToken) == false) { localToken = 0; }
    if (localToken < 0) { localToken = 0; }
    var localStr = String(document.getElementById("wsctRunnerLinkNavURL").value);
    try {
      var localURIservice = Components.classes["@mozilla.org/network/io-service;1"]
                         .getService(Components.interfaces.nsIIOService);
      var localURI = localURIservice.newURI(localStr,null,null);
      if (localURI.schemeIs("http") || localURI.schemeIs("https")) {
        this.wsctProcessQuery(localURI.asciiSpec, localToken);
      } else {
        localPromptMessage = document.getElementById("wsctStrings").getString("wsctURLconnectPromptMessage2");
        localPrompts.alert(null,localPromptTitle,localPromptMessage);
      }
    } catch(e) {
      localPromptMessage = document.getElementById("wsctStrings").getString("wsctURLconnectPromptMessage1");
      localPrompts.alert(null,localPromptTitle,localPromptMessage);
    }
  }
};

window.addEventListener("load", function () { wsctRunner.onLoad(); }, false);
